#
# spec file for package xpaint
#
# Copyright (c) 2017 Packman Team <packman@links2linux.de>
# Copyright (c) 2015 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.links2linux.org/
#


%define soname  lib%{name}rw
%define sover   0
%define appdef  %{_datadir}/X11/app-defaults
Name:           xpaint
Version:        2.10.1
Release:        2.3
Summary:        A color image editing tool
License:        GPL-3.0
Group:          Productivity/Graphics/Bitmap Editors
Url:            http://sourceforge.net/projects/sf-xpaint
Source0:        https://sourceforge.net/projects/sf-xpaint/files/sf-xpaint/%{name}-%{version}/%{name}-%{version}.tar.bz2
Patch0:         %{name}-rpmlint.patch
BuildRequires:  autoconf
BuildRequires:  automake
BuildRequires:  bison
BuildRequires:  flex
BuildRequires:  gcc-c++
BuildRequires:  imake
BuildRequires:  libjbig-devel
BuildRequires:  libjpeg-devel
BuildRequires:  libtool
BuildRequires:  pkgconfig
BuildRequires:  update-desktop-files
BuildRequires:  pkgconfig(ice)
BuildRequires:  pkgconfig(libopenjpeg)
BuildRequires:  pkgconfig(libpgf)
BuildRequires:  pkgconfig(libpng)
BuildRequires:  pkgconfig(libtiff-4)
BuildRequires:  pkgconfig(libxaw3dxft)
BuildRequires:  pkgconfig(sm)
BuildRequires:  pkgconfig(x11)
BuildRequires:  pkgconfig(xaw3d)
BuildRequires:  pkgconfig(xext)
BuildRequires:  pkgconfig(xmu)
BuildRequires:  pkgconfig(xp)
BuildRequires:  pkgconfig(xpm)
BuildRequires:  pkgconfig(xt)
BuildRequires:  pkgconfig(zlib)
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
Xpaint is a color image editing tool which features most standard paint
program options. It allows for the editing of multiple images simultaneously
and supports various formats, including PPM, XBM, TIFF, etc.

%package -n     %{soname}%{sover}
Summary:        Library for xpaint application
Group:          System/Libraries

%description -n %{soname}%{sover}
This package contain the library needed to run a programs compiled using
libxpaintrw.

%package devel
Summary:        Development package for xpaint
Group:          Development/Libraries/C and C++
BuildRequires:  pkgconfig
BuildRequires:  pkgconfig(xaw3d)
Requires:       bison
Requires:       flex
Requires:       libjpeg-devel
Requires:       %{soname}%{sover} = %{version}
Requires:       pkgconfig(ice)
Requires:       pkgconfig(libopenjpeg)
Requires:       pkgconfig(libpng)
Requires:       pkgconfig(sm)
Requires:       pkgconfig(x11)
Requires:       pkgconfig(xaw3d)
Requires:       pkgconfig(xext)
Requires:       pkgconfig(xmu)
Requires:       pkgconfig(xp)
Requires:       pkgconfig(xpm)
Requires:       pkgconfig(xt)

%description devel
This package contains header files and libraries needed to develop
application that use libxpaintrw.

%prep
%setup -q
%patch0 -p1

# Fix for make: command not found
sed -i 's|@echo|echo|g' util/Makefile
# find libpng...
sed -i '/AC_CHECK_HEADER/s/\(libpng\)/\116/g' configure.ac
# Fix of installation directory
sed -i 's|/etc/X11/app-defaults|%{appdef}|' {Makefile.in,Makefile.am}

%build
autoreconf -fiv
%configure

# Remove %{?_smp_mflags} to avoid compilation errors
make -j1
make -j1 -C util

%install
%make_install
%make_install -C util

mkdir -p %{buildroot}/%{_datadir}/pixmaps
install -D -m 644 icons/xpaint* %{buildroot}/%{_datadir}/pixmaps/

mkdir -p %{buildroot}/%{_datadir}/applications
install -D -m 644 xpaint.desktop %{buildroot}/%{_datadir}/applications/
%suse_update_desktop_file %{name}

# --disable-static not found
find %{buildroot} -type f \( -name \*.la -o -name \*.a \) -exec rm {} \;

%post -n %{soname}%{sover} -p /sbin/ldconfig
%postun -n %{soname}%{sover} -p /sbin/ldconfig

%files
%defattr(-,root,root,-)
%doc ChangeLog COPYING README
%{_bindir}/imgmerge
%{_bindir}/pdfconcat
%{_bindir}/pgf2pnm
%{_bindir}/ppmtops
%{_bindir}/xpaint
%{_datadir}/applications/xpaint.desktop
%{_datadir}/pixmaps/xpaint*
%dir %{appdef}
%{appdef}/XPaint*
%dir %{_datadir}/xpaint
%{_datadir}/xpaint/XPaintIcon.xpm
%dir %{_datadir}/xpaint/bin
%{_datadir}/xpaint/bin/xpaint_ocr
%dir %{_datadir}/xpaint/bitmaps
%{_datadir}/xpaint/bitmaps/brushbox.cfg
%dir %{_datadir}/xpaint/bitmaps/brushes
%{_datadir}/xpaint/bitmaps/brushes/*.xpm
%dir %{_datadir}/xpaint/bitmaps/elec
%{_datadir}/xpaint/bitmaps/elec/*.xpm
%dir %{_datadir}/xpaint/help
%{_datadir}/xpaint/help/Help*
%dir %{_datadir}/xpaint/messages
%{_datadir}/xpaint/messages/Messages*
%{_mandir}/man1/%{name}*
%{_mandir}/man1/pdfconcat.1%{ext_man}
%{_mandir}/man1/imgmerge.1%{ext_man}

%files -n %{soname}%{sover}
%defattr(-,root,root,)
%{_libdir}/%{soname}.so.%{sover}*

%files devel
%defattr(-,root,root,)
%{_libdir}/%{soname}.so
%dir %{_datadir}/xpaint/include
%{_datadir}/xpaint/include/*.h
%dir %{_datadir}/xpaint/c_scripts/3d_curves
%{_datadir}/xpaint/c_scripts/3d_curves/*.c
%dir %{_datadir}/xpaint/c_scripts/3d_surfaces
%{_datadir}/xpaint/c_scripts/3d_surfaces/*.c
%dir %{_datadir}/xpaint/c_scripts
%dir %{_datadir}/xpaint/c_scripts/batch
%{_datadir}/xpaint/c_scripts/batch/*.c
%dir %{_datadir}/xpaint/c_scripts/filters
%{_datadir}/xpaint/c_scripts/filters/*.c
%dir %{_datadir}/xpaint/c_scripts/images
%{_datadir}/xpaint/c_scripts/images/*.c
%dir %{_datadir}/xpaint/c_scripts/layers
%{_datadir}/xpaint/c_scripts/layers/*.c
%dir %{_datadir}/xpaint/c_scripts/procedures
%{_datadir}/xpaint/c_scripts/procedures/*.c
%dir %{_datadir}/xpaint/c_scripts/templates
%{_datadir}/xpaint/c_scripts/templates/*.c

%changelog
* Wed Feb  8 2017 aloisio@gmx.com
- Update to 2.10.1
  * Xpaint includes a new command line option
  - btnheight that adjusts appropriately the size of all internal
    widgets in case a big menu font is used (e.g. by setting the
    option -menufont , or by changing the app-defaults file).
    This is very useful if you have a high resolution screen.
    Many small local modifications of various source files in
    the main tree have been necessary for this.
  * A new option -toolmode 0,1,2 can be used to initialize the
    display of the tool window. Also adjustable dynamically by
    resizing that window.
  * Default canvas size has been set to 1024x768
    Related command line options are -canvassize and -winsize
    that can be used independently to adjust the default size of
    canvas and main window.
  * The app-defaults files and help files have been modified
    to accommodate the above additions.
  * The "Print" widget has been improved, and its menubar is now
    again available to adjust page formats (a bug introduced
    probably a long time ago prevented it to work !)
  * A newer version libXaw3dXft-1.6.2e.tar.bz2 has been posted.
    The only change is a 3 lines addition that circumvents (what
    seems to be) a bug occurring of certain X11/Xorg drivers, e.g.
    the intel driver, version 2.99.917. Otherwise this will make
    no difference.
  * Changed the library name librw to libxpaintrw
    to avoid shared library conflicts. Thanks to Michael Orlitzky
    for pointing out the issue.
  * Applied a number of patches from gentoo.org that substantially
    improve the compilation process. Thanks to Julian Ospald
    <hasufell@gentoo.org>
- Dropped xpaint-openjpeg.patch
- Added xpaint-rpmlint.patch
- Spec cleanup
* Sat Feb 28 2015 avvissu@yandex.ru
- Update to 2.9.10.3:
  * only further cosmetic changes, no change in functionality.
- Add package librw0 for xpaint application
- Remove the old build procedure
- Fix png.h not found
- Use %%configure instead of CFLAGS and CXXFLAGS
- Remove %%_smp_mflags to avoid compilation errors
- Use pkgconfig in package names
- Spec file cleanup
* Sat Oct  4 2014 avvissu@yandex.ru
- update to 2.9.10.2
- removed libXaw3dxft6 (used a separate package)
  * add BuildRequires:  libXaw3dxft-devel
- add RPM conditional test %%suse_version for xpaint-openjpeg.patch
- changed Group: for devel
- add manual pages
* Sun Nov 27 2011 detlef@links2linux.de
- new upstream version <2.9.8.3>
  * rw/pgf-util/Makefile : add '-fpermissive' flag to allow compilation
    with recent (more picky!) versions of g++
  * Xaw3dxft/Viewport.c : position of scrollbars can now be adjusted
    through parameters sbShift[X,Y][1,2]. No public API change, so
    this addition should be upward compatible.
  * graphic.c : some small fixes in the shellHandler routine to.
    accommodate odd behavior of scrollbars with xorg recent versions,
    using the new sbShift feature.
* Sun May 22 2011 detlef@links2linux.de
- fix libXaw3dxft6
* Sun Feb 27 2011 detlef@links2linux.de
- new upstream version <2.9.8.2>
  * Integrated patch to facilitate compilation with gcc-4.5
  * app-defaults files : slight improvement of X event management.
    in pull-down menus.
  * print.c : slight improvement of X event management in print widget.
  * fontOp.c : fixed color issue (color not initialized) when moving.
    written text with arrow keys.
  * Very small changes in Xaw3dxft (minor Xaw3dXft.h API update)
* Fri Dec 24 2010 detlef@links2linux.de
- new upstream version <2.9.8.1>
* Sat Nov 13 2010 detlef@links2linux.de
- new upstream version <2.9.8>
* Mon Oct 25 2010 detlef@links2linux.de
- new upstream version <2.9.6.4>
  * A couple of small improvements in spline, polygon, text and
    color operations.
  * fontOp.c, splineOp.c, polygonOp.c : implemented "Backspace"
    key action,  i.e. removing last point or last character;
    "Escape" now entirely restarts the operation from the beginning.
    Other small improvements (including correction of a potential
    segfault occurring in some strange circumstances...);
    polygonOp() code is now also much simpler and easier to read.
  * graphic.c : multiple clicks on any of the three color/pattern
    selection discs now switch primary and secondary colors/patterns.
  * updated accordingly Help files.
* Sat Oct  9 2010 detlef@links2linux.de
- new upstream version <2.9.6.3>
  * ops.h : minor compilation issue fixed.
  * graphic.c : corrected segfault bug of RegionToRGBA channels.
    (occurring only when alpha channel was to be saved.)
  * chroma.c : fixed minor scrolling issue in color variance scrollbars.
  * graphic.c : added new menu lines to proceed more easily to editing.
    of alpha channels or images in memory.
  * updated accordingly Help files, messages and app-defaults files.
* Sat Oct  2 2010 detlef@links2linux.de
- new upstream version <2.9.6.2>
  * iprocess.c : fixed bug occurring only in very rare circumstances
    (creation of image with an alpha channel, being edited and
    compiled on the fly through the embedded C-script editor)
  * print.c : printing was completely broken, as a result of using
    double values instead of float values. Reverted to float !
  * chroma.c, color.c, magnifier.c, fontSelect.c : revert to float !
  * graphic.c : small improvement in ModifyRGB (new routine to
    rescale gray levels linearly from given thresholds).
* Wed Sep 15 2010 detlef@links2linux.de
- new upstream version <2.9.6>
  * rw/rwTable.c, rw/readWriteTGA.c : fixes in TGA format, so as
    to prevent that xpaint could hang on certain non TGA files..
    Make sure anyway that TGA is parsed as a last resort, since TGA
    is a strange format without signature.
  * image.c, iprocess.c, graphic.c : substantial improvements in.
    filter routines :
  - Added new "Merge" filter : helpful to combine smoothly an image
    with the underlying canvas. Works according to 4 different modes
  - Added new "Distortion" filter which can be used to produce
    local deformations
  - Added powerful Floyd-Steinberg algorithm (color quantification
    enhanced with a diffusion process).
  - Replaced "ModifyRGB" by a generalized RGB transformation procedure
    with 7 different modes, including Gamma correction (with independent
    r_gamma, g_gamma, b_gamma parameters), and linear transform.
  - Fixed several shortcomings of "Normalize contrast" and "Emboss"
    routines; "Emboss" now has 2 parameters allowing linear correction.
  - Renamed "Tilt" as "Projective Transform" with several enhancements.
  - Renamed "ImageCopy" as "ImageCopyData" which says more accurately
    what it does.
  * graphic.c : Memory menu : management of R,G,B and alpha channels :
  - Added extraction of red, green, blue, alpha channels from region
  - Added merge procedure for those channels
  * msgedit.c : new utility which can be used to extract strings from
    the English version of "Messages" and combine them with a partially
    localized "Messages_XY" for any other language - useful as well to.
    avoid discrepancies between languages!
  * Many updates to Message and Help files.
* Sat Aug 21 2010 detlef@links2linux.de
- new upstream version <2.9.4>
  * rw/readWriteTGA.c : added support for TGA format (borrowed.
    mostly from mtpaint project).
  * rw/rwTable.c : code clean-up.
  * Paint.c, PaintRegion.c : fixes for certain complex situations.
    involving region selection with masks and alpha channel.
    (Segfault could occur in Fatbits editor under those circumstances).
  * graphic.c : Suppression of alpha channel could lead to segfault.
* Mon Aug  9 2010 detlef@links2linux.de
- new upstream version <2.9.3>
* Tue Aug  3 2010 detlef@links2linux.de
- new upstream version <2.9.2>
* Mon Jul  5 2010 detlef@links2linux.de
- new upstream version <2.9.1.4>
  * fatBitsEdit.c, Paint.c , Paintregion.c : several fixes in.
    handling of alpha channel in fatbits editor - some affecting
    alpha channel image bits.
  * app-defaults : change zoom labels to correct values xx:1 instead
    of 1:xx
  * graphic.c : prevent fatbits editor getting called undeservedly by.
    GetNonDirtyCanvas() routine ; removing alpha channel now moves it
    to memory rather than destroying it right away.
  * rw/readWritePS.c : fix for compilation of TeX/LaTeX files being
    called from random directories.
  * minor fixes throughout - thanks to the SUSE-Packman maintainer
    Detlef Reichelt <detlef@die-mafia.de> for help.
* Sun Jul  4 2010 detlef@links2linux.de
- build with Xaw3dxft <2.9.1-2>
* Fri Jul  2 2010 detlef@links2linux.de
- new upstream version <2.9.1>
* Tue Jan  5 2010 detlef@links2linux.de
- initial build for PackMan <2.8.8>
